
/*:
 * @target MZ
 *
 * @command OexScene_Ex1
 * @desc 
 * @text OexScene_Ex1
 *
 * @command OexScene_Ex2
 * @desc 
 * @text OexScene_Ex2
 *
 * @command OexScene_Ex4
 * @desc 
 * @text OexScene_Ex4
 *
 * @command OexScene_Ex5
 * @desc 
 * @text OexScene_Ex5
 *
 * @command OexScene_Ex6
 * @desc 
 * @text OexScene_Ex6
 *
 * @command OexScene_Pass
 * @desc 
 * @text OexScene_Pass
 *
 * @arg maxLength
 * @type number
 * @min 1
 * @max 10
 * @default 3
 * @text maxLength
 * @desc maxLength
 *
 * @command OexScene_PassJa
 * @desc 
 * @text OexScene_PassJa
 *
 * @arg maxLength
 * @type number
 * @min 1
 * @max 10
 * @default 3
 * @text maxLength
 * @desc maxLength
 *
 *
 */

(() => {
    const pluginName = "plugin_ExScene";

    PluginManager.registerCommand(pluginName, "OexScene_Ex1", args => {
        SceneManager.push(OexScene_Ex1);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex2", args => {
        SceneManager.push(OexScene_Ex2);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex4", args => {
        SceneManager.push(OexScene_Ex4);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex5", args => {
        SceneManager.push(OexScene_Ex5);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex6", args => {
        SceneManager.push(OexScene_Ex6);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Pass", args => {
        SceneManager.push(OexScene_Pass);
        SceneManager.prepareNextScene(0, Number(args.maxLength));
    });
    PluginManager.registerCommand(pluginName, "OexScene_PassJa", args => {
        SceneManager.push(OexScene_PassJa);
        SceneManager.prepareNextScene(0, Number(args.maxLength));
    });

    //-----------------------------------------------------------------------------
    // OexSprite_Monitor1
    //
    // The sprite class with click handling functions.

    function OexSprite_Monitor1() {
        this.initialize(...arguments);
    }

    OexSprite_Monitor1.prototype = Object.create(Sprite.prototype);
    OexSprite_Monitor1.prototype.constructor = OexSprite_Monitor1;

    OexSprite_Monitor1.prototype.initialize = function() {
        Sprite.prototype.initialize.call(this);
        this._state = [0,0,0,0,0,0];
        this._old_state = [0,0,0,0,0,0];
        this._status_sprites = [];
        this.bitmap = ImageManager.loadPicture("color_monitor00");
        for (let i = 0; i < 6; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("color_points00");
            sp.setFrame(0, 0, 70, 70);
            sp.y = 21;
            sp.x = 41 + i * 90;
            sp.visible = false;
            this.addChild(sp);
            this._status_sprites.push(sp);
        }
    };

    OexSprite_Monitor1.prototype.update = function() {
        Sprite.prototype.update.call(this);
        for (let i = 0; i < 6; i++) {
            if (this._old_state[i] != this._state[i]) {
                var sp = this._status_sprites[i];
                if (this._state[i] > 0) {
                    sp.setFrame(70 * (this._state[i] - 1), 0, 70, 70);
                    sp.visible = true;
                } else {
                    sp.visible = false;
                }
            }
            this._old_state[i] = this._state[i];
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex1
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex1() {
        this.initialize(...arguments);
    }

    OexScene_Ex1.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex1.prototype.constructor = OexScene_Ex1;

    OexScene_Ex1.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex1.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._index = 0;
        this._buttonIndex = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex1.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex += 3;
            SoundManager.playCursor();
        }
        this._buttonIndex = this._buttonIndex % 4;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex + 1);
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 230 + 30 + 120 * this._buttonIndex;
        this.finger_sp.y = 400 + 50;
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex1.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex1.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex1.prototype.createButtons = function() {
        this.monitor_sp = new OexSprite_Monitor1();
        this.monitor_sp.x = Graphics.boxWidth / 2 - 320;
        this.monitor_sp.y = 200;
        this.addChild(this.monitor_sp);
        for (let i = 0; i < 4; i++) {
            const ci = (i + 1);
            var sp = new OexSprite_CommonButton("color_buttons00", new Rectangle(100 * i, 0, 100, 100), new Rectangle(100 * i, 100, 100, 100));
            sp.x = Graphics.boxWidth / 2 - 230 + 120 * i;
            sp.y = 400;
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex1.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex1.prototype.pushButton = function(color) {
        if (this._index < 6) {
            this._buttonIndex = color - 1;
            this.monitor_sp._state[this._index] = color;
            this._index += 1;
            OexUtils.playSound("__button45");
            if (this._index >= 6) {
                if (JSON.stringify(this.monitor_sp._state) == JSON.stringify([1,3,1,4,2,1])) {
                    OexUtils.playSound("__button02");
                    $gameSwitches.setValue(28, true);
                }
                this.addLazy(60, this.popScene.bind(this));
            }
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex2
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex2() {
        this.initialize(...arguments);
    }

    OexScene_Ex2.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex2.prototype.constructor = OexScene_Ex2;

    OexScene_Ex2.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex2.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndex = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex2.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndex -= 2;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndex += 2;
            SoundManager.playCursor();
        }
        this._buttonIndex = (this._buttonIndex + 6) % 6;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        if (this._buttonIndex < 4) {
            this.finger_sp.x = Graphics.boxWidth / 2 - 120 + (this._buttonIndex % 2) * 200;
            this.finger_sp.y = Graphics.boxHeight / 2 - 280 + Math.floor(this._buttonIndex / 2) * 200;
        } else {
            this.finger_sp.x = Graphics.boxWidth / 2;
            this.finger_sp.y = 550;
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex2.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex2.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex2.prototype.createButtons = function() {
        this.monitor_sp = new Sprite();
        this.monitor_sp.bitmap = ImageManager.loadPicture("panels00");
        this.monitor_sp.x = Graphics.boxWidth / 2 - 220;
        this.monitor_sp.y = Graphics.boxHeight / 2 - 320;
        this.addChild(this.monitor_sp);
        var _frames = [];
        for (let i = 0; i < 5; i++) {
            _frames.push(new Rectangle(190 * i, 0, 190, 190));
        }
        this._toggles = [];
        for (let i = 0; i < 4; i++) {
            const ci = i;
            var sp = new OexSpriteToggleButton("triangle_node", _frames);
            sp.x = Graphics.boxWidth / 2 - 220 + (i % 2) * 200 + 25;
            sp.y = Graphics.boxHeight / 2 - 320 + Math.floor(i / 2) * 200 + 25;
            sp.setClickHandler(this.setButtonIndex.bind(this, ci));
            this.addChild(sp);
            this._toggles.push(sp);
        }
        this._decision = new OexSprite_CommonButton("white_buttons00", new Rectangle(0, 0, 200, 100), new Rectangle(0, 100, 200, 100));
        this._decision.x = Graphics.boxWidth / 2 - 100;
        this._decision.y = 500;
        this._decision.setClickHandler(this.pushButton.bind(this, 5));
        this.addChild(this._decision);
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex2.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex2.prototype.setButtonIndex = function(_index) {
        this._buttonIndex = _index;
    };

    OexScene_Ex2.prototype.pushButton = function(_index) {
        if (_index < 4) {
            this._toggles[_index].onClick();
        } else {
            OexUtils.playSound("__button45");
            if (this._toggles[0]._state == 2 &&
                this._toggles[1]._state == 0 &&
                this._toggles[2]._state == 4 &&
                this._toggles[3]._state == 2) {
                OexUtils.playSound("__button02");
                $gameSwitches.setValue(66, true);
            }
            this.addLazy(60, this.popScene.bind(this));
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex4
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex4() {
        this.initialize(...arguments);
    }

    OexScene_Ex4.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex4.prototype.constructor = OexScene_Ex4;

    OexScene_Ex4.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex4.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndexX = 0;
        this._buttonIndexY = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex4.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndexX += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndexX -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndexY -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndexY += 1;
            SoundManager.playCursor();
        }
        this._buttonIndexX = (this._buttonIndexX + 7) % 7;
        this._buttonIndexY = (this._buttonIndexY + 5) % 5;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndexX, this._buttonIndexY);
        }
        if (this._buttonIndexY < 4) {
            this.finger_sp.x = Graphics.boxWidth / 2 - 350 + 50 + this._buttonIndexX * 100;
            this.finger_sp.y = 100 + 50 + 100 * this._buttonIndexY;
        } else {
            this.finger_sp.x = Graphics.boxWidth / 2;
            this.finger_sp.y = 600;
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex4.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex4.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex4.prototype.createButtons = function() {
        this.monitor_sp = new Sprite();
        this.monitor_sp.bitmap = ImageManager.loadPicture("panels00");
        this.monitor_sp.x = Graphics.boxWidth / 2 - 220;
        this.monitor_sp.y = Graphics.boxHeight / 2 - 320;
        this.addChild(this.monitor_sp);
        var _frames = [];
        for (let i = 0; i < 2; i++) {
            _frames.push(new Rectangle(100 * i, 0, 100, 100));
        }
        this._toggles = [];
        for (let i = 0; i < 7; i++) {
            var tmp = [];
            for (let j = 0; j < 4; j++) {
                const ci = i;
                const cj = j;
                var sp = new OexSpriteToggleButton("safe_button00", _frames);
                sp.x = Graphics.boxWidth / 2 - 350 + i * 100;
                sp.y = 100 + 100 * j;
                sp.setClickHandler(this.setButtonIndex.bind(this, ci, cj));
                this.addChild(sp);
                tmp.push(sp);
            }
            this._toggles.push(tmp);
        }
        this._decision = new OexSprite_CommonButton("white_buttons00", new Rectangle(0, 0, 200, 100), new Rectangle(0, 100, 200, 100));
        this._decision.x = Graphics.boxWidth / 2 - 100;
        this._decision.y = 550;
        this._decision.setClickHandler(this.pushButton.bind(this, 0, 4));
        this.addChild(this._decision);
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex4.prototype.setButtonIndex = function(_indexx, _indexy) {
        this._buttonIndexX = _indexx;
        this._buttonIndexY = _indexy;
    };

    OexScene_Ex4.prototype.pushButton = function(_indexX, _indexY) {
        if (_indexY < 4) {
            this._toggles[_indexX][_indexY].onClick();
        } else {
            OexUtils.playSound("__button02");
            this.addLazy(60, this.popScene.bind(this));
        }
    };

    OexScene_Ex4.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };






    //-----------------------------------------------------------------------------
    // OexScene_Ex6
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex6() {
        this.initialize(...arguments);
    }

    OexScene_Ex6.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex6.prototype.constructor = OexScene_Ex6;

    OexScene_Ex6.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex6.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        if ($gameTemp.number_mappings) {
        } else {
            $gameTemp.number_mappings = [10,10,10,10,10,10,10,10,10,10];
        }
        this._index = 0;
        this._buttonIndex = 0;
        this._index2num = [2,7,4,6,0,5,1,3,8,9];
        this._selected = [];
        this._think_valid = $gameSwitches.value(69);
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex6.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            if (this._buttonIndex < 10) {
                this._buttonIndex += 1;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            if (this._buttonIndex > 0) {
                this._buttonIndex -= 1;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            if (this._buttonIndex < 5) {
                this._buttonIndex += 5;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            if (this._buttonIndex >= 5) {
                this._buttonIndex -= 5;
            }
            SoundManager.playCursor();
        }
        if (!this._think_valid) {
            this._buttonIndex = (this._buttonIndex + 10) % 10;
        }
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        for (let i = 0; i < 4; i++) {
            var sp = this.monitor_points[i];
            sp.visible = (this._selected.length > i);
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 320 + 30 + 120 * (this._buttonIndex % 5);
        this.finger_sp.y = 300 + 50 + 100 * Math.floor(this._buttonIndex / 5);
        if (this._buttonIndex == 10) {
            this.finger_sp.x = Graphics.boxWidth / 2 - 230 + 30;
            this.finger_sp.y = 550 + 50;
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex6.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex6.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex6.prototype.createButtons = function() {
        this.monitor_sp = new Sprite();
        this.monitor_sp.bitmap = ImageManager.loadPicture("digit_monitor00");
        this.monitor_sp.x = Graphics.boxWidth / 2 - 320;
        this.monitor_sp.y = 100;
        this.addChild(this.monitor_sp);
        this.monitor_points = [];
        for (let i = 0; i < 4; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("digit_point00");
            sp.x = Graphics.boxWidth / 2 - 320 + 25 + 100 * i;
            sp.y = 100 + 25;
            sp.visible = false;
            this.addChild(sp);
            this.monitor_points.push(sp);
        }
        for (let i = 0; i < 10; i++) {
            const ci = (i);
            var sp = new OexSprite_CommonButton("digit_button00", new Rectangle(0, 0, 100, 100), new Rectangle(100, 0, 100, 100));
            sp.x = Graphics.boxWidth / 2 - 320 + 120 * (i % 5);
            sp.y = 300 + 100 * Math.floor(i / 5);
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
            var num = this._index2num[i];
            var num0 = $gameTemp.number_mappings[num];
            var sp2 = new Sprite();
            sp2.bitmap = ImageManager.loadPicture("digital_n0");
            sp2.setFrame(100 * (num0 % 5), 100 * Math.floor(num0 / 5), 100, 100);
            sp2.x = Graphics.boxWidth / 2 - 320 + 120 * (i % 5);
            sp2.y = 300 + 100 * Math.floor(i / 5);
            sp2.opacity = 96;
            if (num0 == 10) {
                sp2.visible = false;
            }
            this.addChild(sp2);
            var sp3 = new Sprite();
            sp3.bitmap = ImageManager.loadPicture("digital_n1");
            sp3.setFrame(100 * (num % 5), 100 * Math.floor(num / 5), 100, 100);
            sp3.x = Graphics.boxWidth / 2 - 320 + 120 * (i % 5);
            sp3.y = 300 + 100 * Math.floor(i / 5);
            this.addChild(sp3);
        }
        if (this._think_valid) {
            var sp0 = new OexSprite_CommonButton("digit_think00", new Rectangle(0, 0, 96, 48), new Rectangle(100, 0, 96, 48));
            sp0.x = Graphics.boxWidth / 2 - 230;
            sp0.y = 550;
            sp0.setClickHandler(this.pushButton.bind(this, 10));
            this.addChild(sp0);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex6.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex6.prototype.pushButton = function(_index) {
        this._buttonIndex = _index;
        if (_index == 10) {
            OexUtils.playSound("__button02");
            SceneManager.push(OexScene_Ex6Think);
            return;
        }
        OexUtils.playSound("__button45");
        var num = this._index2num[_index];
        this._selected.push(num);
        if (this._selected.length == 4) {
            var digit = this._selected[0] * 1000 + this._selected[1] * 100 + this._selected[2] * 10 + this._selected[3] * 1;
            if (digit == 4027 && this._think_valid) {
                OexUtils.playSound("__button02");
                $gameSwitches.setValue(70, true);
            } else {
                OexUtils.playSound("Buzzer1");
            }
            this.addLazy(60, this.popScene.bind(this));
        }
    };


    //-----------------------------------------------------------------------------
    // OexScene_Ex6Think
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex6Think() {
        this.initialize(...arguments);
    }

    OexScene_Ex6Think.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex6Think.prototype.constructor = OexScene_Ex6Think;

    OexScene_Ex6Think.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex6Think.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        if ($gameTemp.number_mappings) {
        } else {
            $gameTemp.number_mappings = [10,10,10,10,10,10,10,10,10,10];
        }
        this._index = 0;
        this._buttonIndex = 0;
        this._index2num = [2,7,4,6,0,5,1,3,8,9];
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex6Think.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("down")) {
            if (this._buttonIndex < 9) {
                this._buttonIndex += 1;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            if (this._buttonIndex > 0) {
                this._buttonIndex -= 1;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("right")) {
            if (this._buttonIndex < 5) {
                this._buttonIndex += 5;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            if (this._buttonIndex >= 5) {
                this._buttonIndex -= 5;
            }
            SoundManager.playCursor();
        }
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 320 + 300 * Math.floor(this._buttonIndex / 5) + 130;
        this.finger_sp.y = 100 + 100 * (this._buttonIndex % 5) + 75;
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex6Think.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex6Think.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex6Think.prototype.createButtons = function() {
        this._numberpanel = [];
        for (let i = 0; i < 10; i++) {
            const ci = (i);
            var sp = new OexSprite_CommonButton("digital_frame1", new Rectangle(0, 0, 200, 100), new Rectangle(0, 0, 200, 100));
            sp.x = Graphics.boxWidth / 2 - 320 + 300 * Math.floor(i / 5);
            sp.y = 100 + 100 * (i % 5);
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
            var sp2 = new Sprite();
            var num = this._index2num[i];
            sp2.bitmap = ImageManager.loadPicture("digital_n1");
            sp2.setFrame(100 * (num % 5), 100 * Math.floor(num / 5), 100, 100);
            sp2.x = Graphics.boxWidth / 2 - 320 + 300 * Math.floor(i / 5);
            sp2.y = 100 + 100 * (i % 5);
            this.addChild(sp2);
            var sp3 = new Sprite();
            var num0 = $gameTemp.number_mappings[num];
            sp3.bitmap = ImageManager.loadPicture("digital_n0");
            sp3.setFrame(100 * (num0 % 5), 100 * Math.floor(num0 / 5), 100, 100);
            sp3.x = Graphics.boxWidth / 2 - 320 + 300 * Math.floor(i / 5) + 100;
            sp3.y = 100 + 100 * (i % 5);
            this.addChild(sp3);
            this._numberpanel.push(sp3);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex6Think.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex6Think.prototype.pushButton = function(_index) {
        if (this._buttonIndex == _index) {
            var num = this._index2num[_index];
            var num0 = $gameTemp.number_mappings[num];
            var nextnum = num0 + 1;
            if (nextnum > 10) {
                nextnum = 0;
            }
            while (true) {
                if (nextnum == 10) {
                    break;
                }
                var flag = false;
                for (let i = 0; i < 10; i++) {
                    if ($gameTemp.number_mappings[i] == nextnum) {
                        flag = true;
                    }
                }
                if (flag) {
                    nextnum += 1;
                } else {
                    break;
                }
            }
            num0 = nextnum;
            if (num0 > 10) {
                num0 = 0;
            }
            $gameTemp.number_mappings[num] = num0;
            var sp = this._numberpanel[_index];
            sp.setFrame(100 * (num0 % 5), 100 * Math.floor(num0 / 5), 100, 100);
        }
        this._buttonIndex = _index;
        OexUtils.playSound("__button45");
    };

    //-----------------------------------------------------------------------------
    // OexWindow_NameEdit
    //

    function OexWindow_NameEdit() {
        this.initialize(...arguments);
    }

    OexWindow_NameEdit.prototype = Object.create(Window_NameEdit.prototype);
    OexWindow_NameEdit.prototype.constructor = OexWindow_NameEdit;

    OexWindow_NameEdit.prototype.initialize = function(rect) {
        Window_NameEdit.prototype.initialize.call(this, rect);
    };

    OexWindow_NameEdit.prototype.setup = function(actor, maxLength) {
        this._actor = null;
        this._maxLength = maxLength;
        this._name = "";
        this._index = this._name.length;
        this._defaultName = this._name;
    };

    OexWindow_NameEdit.prototype.faceWidth = function() {
        return 0;
    };

    OexWindow_NameEdit.prototype.drawActorFace = function() {
    };

    OexWindow_NameEdit.prototype.back = function() {
        if (this._index > 0) {
            this._index--;
            this._name = this._name.slice(0, this._index);
            this.refresh();
            return true;
        } else {
            SceneManager.pop();
            return false;
        }
    };

    //-----------------------------------------------------------------------------
    // OexWindow_NameInput
    //
    // The window for selecting text characters on the name input screen.

    function OexWindow_NameInput() {
        this.initialize(...arguments);
    }

    OexWindow_NameInput.prototype = Object.create(Window_Selectable.prototype);
    OexWindow_NameInput.prototype.constructor = OexWindow_NameInput;

    OexWindow_NameInput.JAPAN3 =
            [ "Ａ","Ｂ","Ｃ","Ｄ","Ｅ",
              "Ｆ","Ｇ","Ｈ","Ｉ","Ｊ",
              "Ｋ","Ｌ","Ｍ","Ｎ","Ｏ",
              "Ｐ","Ｑ","Ｒ","Ｓ","Ｔ",
              "Ｕ","Ｖ","Ｗ","Ｘ","Ｙ",
              "Ｚ","決定"];

    OexWindow_NameInput.prototype.initialize = function(rect) {
        Window_Selectable.prototype.initialize.call(this, rect);
        this._editWindow = null;
        this._page = 0;
        this._index = 0;
    };

    OexWindow_NameInput.prototype.setEditWindow = function(editWindow) {
        this._editWindow = editWindow;
        this.refresh();
        this.updateCursor();
        this.activate();
    };

    OexWindow_NameInput.prototype.table = function() {
        return [OexWindow_NameInput.JAPAN3];
    };

    OexWindow_NameInput.prototype.maxCols = function() {
        return 10;
    };

    OexWindow_NameInput.prototype.maxItems = function() {
        return OexWindow_NameInput.JAPAN3.length;
    };

    OexWindow_NameInput.prototype.itemWidth = function() {
        return Math.floor((this.innerWidth - this.groupSpacing()) / 10);
    };

    OexWindow_NameInput.prototype.groupSpacing = function() {
        return 24;
    };

    OexWindow_NameInput.prototype.character = function() {
        return this._index < this.maxItems() - 1 ? this.table()[this._page][this._index] : "";
    };

    OexWindow_NameInput.prototype.isPageChange = function() {
        return false;
    };

    OexWindow_NameInput.prototype.isOk = function() {
        return this._index === this.maxItems() - 1;
    };

    OexWindow_NameInput.prototype.itemRect = function(index) {
        const itemWidth = this.itemWidth();
        const itemHeight = this.itemHeight();
        const colSpacing = this.colSpacing();
        const rowSpacing = this.rowSpacing();
        const groupSpacing = this.groupSpacing();
        const col = index % 10;
        const group = Math.floor(col / 5);
        const x = col * itemWidth + group * groupSpacing + colSpacing / 2;
        const y = Math.floor(index / 10) * itemHeight + rowSpacing / 2;
        const width = itemWidth - colSpacing;
        const height = itemHeight - rowSpacing;
        return new Rectangle(x, y, width, height);
    };

    OexWindow_NameInput.prototype.drawItem = function(index) {
        const table = this.table();
        const character = table[this._page][index];
        const rect = this.itemLineRect(index);
        this.drawText(character, rect.x, rect.y, rect.width, "center");
    };

    OexWindow_NameInput.prototype.updateCursor = function() {
        const rect = this.itemRect(this._index);
        this.setCursorRect(rect.x, rect.y, rect.width, rect.height);
    };

    OexWindow_NameInput.prototype.isCursorMovable = function() {
        return this.active;
    };

    OexWindow_NameInput.prototype.cursorDown = function(wrap) {
        if (this._index + 10 < this.maxItems()) {
            this._index = (this._index + 10);
        }
    };

    OexWindow_NameInput.prototype.cursorUp = function(wrap) {
        if (this._index >= 10) {
            this._index = (this._index - 10);
        }
    };

    OexWindow_NameInput.prototype.cursorRight = function(wrap) {
        if (this._index + 1 < this.maxItems()) {
            this._index = (this._index + 1);
        }
    };

    OexWindow_NameInput.prototype.cursorLeft = function(wrap) {
        if (this._index >= 1) {
            this._index = (this._index - 1);
        }
    };

    OexWindow_NameInput.prototype.cursorPagedown = function() {
    };

    OexWindow_NameInput.prototype.cursorPageup = function() {
    };

    OexWindow_NameInput.prototype.processCursorMove = function() {
        const lastPage = this._page;
        Window_Selectable.prototype.processCursorMove.call(this);
        this.updateCursor();
        if (this._page !== lastPage) {
            this.playCursorSound();
        }
    };

    OexWindow_NameInput.prototype.processHandling = function() {
        if (this.isOpen() && this.active) {
            if (Input.isTriggered("shift")) {
                this.processJump();
            }
            if (Input.isRepeated("cancel")) {
                this.processBack();
            }
            if (Input.isRepeated("ok")) {
                this.processOk();
            }
        }
    };

    OexWindow_NameInput.prototype.isCancelEnabled = function() {
        return true;
    };

    OexWindow_NameInput.prototype.processCancel = function() {
        this.processBack();
    };

    OexWindow_NameInput.prototype.processJump = function() {
        if (this._index !== this.maxItems() - 1) {
            this._index = this.maxItems() - 1;
            this.playCursorSound();
        }
    };

    OexWindow_NameInput.prototype.processBack = function() {
        if (this._editWindow.back()) {
            SoundManager.playCancel();
        }
    };

    OexWindow_NameInput.prototype.processOk = function() {
        if (this.character()) {
            this.onNameAdd();
        } else if (this.isPageChange()) {
            this.playOkSound();
            this.cursorPagedown();
        } else if (this.isOk()) {
            this.onNameOk();
        }
    };

    OexWindow_NameInput.prototype.onNameAdd = function() {
        if (this._editWindow.add(this.character())) {
            this.playOkSound();
        } else {
            this.playBuzzerSound();
        }
    };

    OexWindow_NameInput.prototype.onNameOk = function() {
        if (this._editWindow.name() === "") {
            this.playBuzzerSound();
        } else {
            this.playOkSound();
            this.callOkHandler();
        }
    };


    //-----------------------------------------------------------------------------
    // OexWindow_NameInputJa
    //
    // The window for selecting text characters on the name input screen.

    function OexWindow_NameInputJa() {
        this.initialize(...arguments);
    }

    OexWindow_NameInputJa.prototype = Object.create(OexWindow_NameInput.prototype);
    OexWindow_NameInputJa.prototype.constructor = OexWindow_NameInputJa;

    // prettier-ignore
    OexWindow_NameInputJa.LATIN1 =
            [ "A","B","C","D","E",
              "F","G","H","I","J",
              "K","L","M","N","O",
              "P","Q","R","S","T",
              "U","V","W","X","Y",
              "Z","","","","",
              "0","1","2","3","4",
              "5","6","7","8","9",
              "","","","","",
              "","","","","",
              "","","","","",
              "","","","","",
              "","","","","",
              "","","","","",
              "","OK"];

    OexWindow_NameInputJa.prototype.initialize = function(rect) {
        OexWindow_NameInput.prototype.initialize.call(this, rect);
    };

    OexWindow_NameInputJa.prototype.table = function() {
        return [OexWindow_NameInputJa.LATIN1];
    };

    OexWindow_NameInputJa.prototype.maxItems = function() {
        return OexWindow_NameInputJa.LATIN1.length;
    };

    //-----------------------------------------------------------------------------
    // OexScene_Pass
    //

    function OexScene_Pass() {
        this.initialize(...arguments);
    }

    OexScene_Pass.prototype = Object.create(Scene_MenuBase.prototype);
    OexScene_Pass.prototype.constructor = OexScene_Pass;

    OexScene_Pass.prototype.initialize = function() {
        Scene_MenuBase.prototype.initialize.call(this);
    };

    OexScene_Pass.prototype.prepare = function(actorId, maxLength) {
        this._actorId = actorId;
        this._maxLength = maxLength;
    };

    OexScene_Pass.prototype.create = function() {
        Scene_MenuBase.prototype.create.call(this);
        this._actor = $gameActors.actor(this._actorId);
        this.createEditWindow();
        this.createInputWindow();
    };

    OexScene_Pass.prototype.start = function() {
        Scene_MenuBase.prototype.start.call(this);
        this._editWindow.refresh();
    };

    OexScene_Pass.prototype.createEditWindow = function() {
        const rect = this.editWindowRect();
        this._editWindow = new OexWindow_NameEdit(rect);
        this._editWindow.setup(this._actor, this._maxLength);
        this.addWindow(this._editWindow);
    };

    OexScene_Pass.prototype.editWindowRect = function() {
        const inputWindowHeight = this.calcWindowHeight(9, true);
        const padding = $gameSystem.windowPadding();
        const ww = 600;
        const wh = ImageManager.faceHeight + padding * 2;
        const wx = (Graphics.boxWidth - ww) / 2;
        const wy = (Graphics.boxHeight - (wh + inputWindowHeight + 8)) / 2;
        return new Rectangle(wx, wy, ww, wh);
    };

    OexScene_Pass.prototype.createInputWindow = function() {
        const rect = this.inputWindowRect();
        this._inputWindow = new OexWindow_NameInput(rect);
        this._inputWindow.setEditWindow(this._editWindow);
        this._inputWindow.setHandler("ok", this.onInputOk.bind(this));
        this.addWindow(this._inputWindow);
    };

    OexScene_Pass.prototype.inputWindowRect = function() {
        const wx = this._editWindow.x;
        const wy = this._editWindow.y + this._editWindow.height + 8;
        const ww = this._editWindow.width;
        const wh = this.calcWindowHeight(9, true);
        return new Rectangle(wx, wy, ww, wh);
    };

    OexScene_Pass.prototype.onInputOk = function() {
        var pass = this._editWindow.name();
        if (pass == "DEERS") {
            $gameSwitches.setValue(63, true);
        }
        this.popScene();
    };

    //-----------------------------------------------------------------------------
    // OexScene_PassJa
    //

    function OexScene_PassJa() {
        this.initialize(...arguments);
    }

    OexScene_PassJa.prototype = Object.create(OexScene_Pass.prototype);
    OexScene_PassJa.prototype.constructor = OexScene_PassJa;

    OexScene_PassJa.prototype.initialize = function() {
        OexScene_Pass.prototype.initialize.call(this);
    };

    OexScene_PassJa.prototype.createInputWindow = function() {
        const rect = this.inputWindowRect();
        this._inputWindow = new OexWindow_NameInputJa(rect);
        this._inputWindow.setEditWindow(this._editWindow);
        this._inputWindow.setHandler("ok", this.onInputOk.bind(this));
        this.addWindow(this._inputWindow);
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex5
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex5() {
        this.initialize(...arguments);
    }

    OexScene_Ex5.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex5.prototype.constructor = OexScene_Ex5;

    OexScene_Ex5.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex5.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndex = 0;
        this._selectedIndex = -1;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex5.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        this._buttonIndex = (this._buttonIndex + 5) % 5;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        for (let i = 0; i < 5; i++) {
            var sp = this._booksp[i];
            sp.x = Graphics.boxWidth / 2 - 400 + 200 + this._book_position[i] * 100;
            sp.y = Graphics.boxHeight / 2 + 300;
            if (this._book_position[i] == this._selectedIndex) {
                sp.opacity = 128;
            } else {
                sp.opacity = 255;
            }
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 400 + 200 + this._buttonIndex * 100;
        this.finger_sp.y = Graphics.boxHeight / 2;
        this.finger_sp2.x = Graphics.boxWidth / 2 - 400 + 200 + this._selectedIndex * 100;
        this.finger_sp2.y = Graphics.boxHeight / 2;
        this.finger_sp2.visible = (this._selectedIndex >= 0);
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex5.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex5.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex5.prototype.createButtons = function() {
        this.back_sp = new Sprite();
        this.back_sp.bitmap = ImageManager.loadPicture("bookback00");
        this.back_sp.x = Graphics.boxWidth / 2 - 400;
        this.back_sp.y = Graphics.boxHeight / 2 - 350;
        this.addChild(this.back_sp);
        this._book_position = [4,2,3,1,0];
        this._booksp = [];
        for (let i = 0; i < 5; i++) {
            var sp = new OexSprite_CommonButton("book0" + (i + 1), new Rectangle(0, 0, 100, 500), new Rectangle(0, 0, 100, 500));
            sp.x = Graphics.boxWidth / 2 - 400 + this._book_position[i] * 100;
            sp.y = Graphics.boxHeight / 2 + 300;
            sp.anchor.x = 0.5;
            sp.anchor.y = 1.0;
            this.addChild(sp);
            this._booksp.push(sp);
            const ci = i;
            sp.setClickHandler(this.pushBook.bind(this, ci));
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.finger_sp2 = new Sprite();
        this.finger_sp2.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp2);
        this.createCancelButton();
    };

    OexScene_Ex5.prototype.pushBook = function(_book_index) {
        this.pushButton(this._book_position[_book_index]);
    };

    OexScene_Ex5.prototype.pushButton = function(_index) {
        OexUtils.playSound("__button45");
        if (_index != this._buttonIndex) {
            this._buttonIndex = _index;
            return;
        }
        if (this._selectedIndex < 0) {
            this._buttonIndex = _index;
            this._selectedIndex = _index;
        } else {
            this._buttonIndex = _index;
            var tmp1 = 0;
            var tmp2 = 0;
            for (let i = 0; i < 5; i++) {
                if (this._book_position[i] == this._buttonIndex) {
                    tmp1 = i;
                    break;
                }
            }
            for (let i = 0; i < 5; i++) {
                if (this._book_position[i] == this._selectedIndex) {
                    tmp2 = i;
                    break;
                }
            }
            this._book_position[tmp1] = this._selectedIndex;
            this._book_position[tmp2] = this._buttonIndex;
            this._selectedIndex = -1;
        }
    };

    OexScene_Ex5.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };



})();
