
function Sprite_Movable() {
    this.initialize(...arguments);
}

(() => {
    const pluginName = "plugin_MovableSprites";

    //-----------------------------------------------------------------------------
    // Sprite_Movable
    //
    // The sprite class with click handling functions.

    Sprite_Movable.prototype = Object.create(Sprite_Clickable.prototype);
    Sprite_Movable.prototype.constructor = Sprite_Movable;

    Sprite_Movable.prototype.initialize = function() {
        Sprite_Clickable.prototype.initialize.call(this);
        this._movable = true;
        this._lastX = 0;
        this._lastY = 0;
        this._tmp_press = false;
    };

    Sprite_Movable.prototype.update = function() {
        Sprite_Clickable.prototype.update.call(this);
        this.processTouchMove();
    };

    Sprite_Movable.prototype.processTouchMove = function() {
        if (this.isMoveEnabled()) {
            if (!this._tmp_press && this._pressed) {
                this._lastX = TouchInput.x;
                this._lastY = TouchInput.y;
            }
            if (this._pressed && TouchInput.isMoved()) {
                this.onMoved(TouchInput.x - this._lastX, TouchInput.y - this._lastY);
            }
            this._tmp_press = this._pressed;
        } else {
            this._tmp_press = false;
        }
    };

    Sprite_Movable.prototype.isMoveEnabled = function() {
        return this.isClickEnabled() && this._movable;
    };

    Sprite_Movable.prototype.onMoved = function(_slipX, _slipY) {
        this.x += _slipX;
        this.y += _slipY;
    };

})();
