
function OexSpriteContainer() {
    this.initialize.apply(this, arguments);
}

(() => {
    const pluginName = "plugin_zindex";

    //-----------------------------------------------------------------------------
    // OexSpriteContainer
    //

    OexSpriteContainer.prototype = Object.create(PIXI.Container.prototype);
    OexSpriteContainer.prototype.constructor = OexSpriteContainer;

    OexSpriteContainer.prototype.initialize = function() {
        PIXI.Container.call(this);
        this.refresh();
    };

    OexSpriteContainer.prototype.refresh = function() {
    };

    OexSpriteContainer.prototype.isReady = function() {
        return true;
    };

    OexSpriteContainer.prototype.update = function() {
        this.children.forEach(function(child) {
            if (child.update) {
                child.update();
            }
        });
    };

    OexSpriteContainer.prototype.updateTransform = function() {
        this._sortChildren();
        PIXI.Container.prototype.updateTransform.call(this);
    };

    OexSpriteContainer.prototype._sortChildren = function() {
        this.children.sort(this._compareChildOrder.bind(this));
    };

    OexSpriteContainer.prototype._compareChildOrder = function(a, b) {
        if (a.z !== b.z) {
            return a.z - b.z;
        } else if (a.y !== b.y) {
            return a.y - b.y;
        } else {
            return a.spriteId - b.spriteId;
        }
    };

})();
